﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using ESPlus.Rapid;
using ESPlus.Application.Basic;


/*
 * 本demo采用的是ESFramework的免费版本，若想获取ESFramework其它版本，请联系 www.oraycn.com 或 QQ：168757008。
 * 
 */
namespace ESFramework.Demos.DynamicGroup.Client
{
   
    static class Program
    {
        /// <summary>
        /// 应用程序的主入口点。
        /// </summary>
        [STAThread]
        static void Main()
        {
            try
            {
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);

                LoginForm loginForm = new LoginForm();
                if (loginForm.ShowDialog() != DialogResult.OK)
                {
                    return;
                }
                IRapidPassiveEngine rapidPassiveEngine = ESPlus.Rapid.RapidEngineFactory.CreatePassiveEngine();
                MainForm mainForm = new MainForm();
                LogonResponse logonResponse = rapidPassiveEngine.Initialize(loginForm.UserID, "", "127.0.0.1", 4530, mainForm);
                if (logonResponse.LogonResult == LogonResult.HadLoggedOn)
                {
                    MessageBox.Show("已经在其它地方登陆！");
                    return;
                }

                GroupTools groupTools = new GroupTools(rapidPassiveEngine);
                JoinGroupForm joinGroupform = new JoinGroupForm(groupTools, loginForm.UserID);
                if (joinGroupform.ShowDialog() != DialogResult.OK)
                {
                    return;
                }
                
                
                mainForm.Initialize(loginForm.UserID, joinGroupform.CurrentGroupID, rapidPassiveEngine);

                Application.Run(mainForm);
            }
            catch (Exception ee)
            {
                MessageBox.Show(ee.Message);
            }
        }
    }
}